using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Optimization;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Analysis {

  [Item("DoubleArraySnapshotCreaterAnalyzer", "An operator that adds lightweight snapshots to all DoubleArrays`s for later analysis.")]
  [StorableClass]
  public sealed class DoubleArraySnapshotCreaterAnalyzer : SnapshotCreaterAnalyzer<double>, IAnalyzer {
    [StorableConstructor]
    private DoubleArraySnapshotCreaterAnalyzer(bool deserializing) : base(deserializing) { }
    private DoubleArraySnapshotCreaterAnalyzer(DoubleArraySnapshotCreaterAnalyzer original, Cloner cloner) : base(original, cloner) { }
    public DoubleArraySnapshotCreaterAnalyzer() { }
    public override IDeepCloneable Clone(Cloner cloner) { return new DoubleArraySnapshotCreaterAnalyzer(this, cloner); }
  }
}